package jp.test.animation.tween;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.RotateAnimation;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class TweenAnimationTestActivity extends Activity {
	
	String[] mAnimations = new String[]{
		"Alpha", "Transrate", 
		"Set(Alpha + Transrate)",
		"Set(Alpha + Transrate + Rotation + Scale)",
		"from XML Resource",
	};
	
	int mCurrentAnimation;

	// UI
	TextView mTextCurAnim;
	Button mBtnSelect, mBtnAnimText, mBtnAnimImage, mBtnAnimBoth;

	// Aj[Vr[
	LinearLayout mLayoutAnim;
	ImageView    mImageAnim ;
	TextView     mTextAnim  ;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        mTextCurAnim  = (TextView) findViewById( R.id.text_current_anim );
        mBtnSelect    = (Button  ) findViewById( R.id.button_select_animation );
        
        mBtnAnimText  = (Button) findViewById( R.id.button_anim_text  );
        mBtnAnimImage = (Button) findViewById( R.id.button_anim_image );
        mBtnAnimBoth  = (Button) findViewById( R.id.button_anim_both  );
        mLayoutAnim = (LinearLayout) findViewById( R.id.layout_anim_field );
        mImageAnim  = (ImageView   ) findViewById( R.id.image_anim_image  );
        mTextAnim   = (TextView    ) findViewById( R.id.text_anim_text    );
        
        mBtnSelect   .setOnClickListener(mClickListener);
        mBtnAnimText .setOnClickListener(mClickListener);
        mBtnAnimImage.setOnClickListener(mClickListener);
        mBtnAnimBoth .setOnClickListener(mClickListener);
        
        updateUi( false );
    }
    
    // OnClickListener
    View.OnClickListener mClickListener = new View.OnClickListener() {
		public void onClick(View v) {
			if( v == mBtnSelect ){ updateUi(true); }
			else if( v == mBtnAnimImage ){ animationTest(mImageAnim ); }
			else if( v == mBtnAnimText  ){ animationTest(mTextAnim  ); }
			else if( v == mBtnAnimBoth  ){ animationTest(mLayoutAnim); }
		}
	};
    
	
	// UI̕\XV
	void updateUi( boolean next ){
		if( next ){
			mCurrentAnimation++;
			mCurrentAnimation = mCurrentAnimation % mAnimations.length;
		}
		mTextCurAnim.setText( mAnimations[mCurrentAnimation] );
	}
	
	
	// Aj[VeXg
	void animationTest(View v){
		if     ( mCurrentAnimation == 0 ){ alphaAnimationTest(v); }
		else if( mCurrentAnimation == 1 ){ transAnimationTest(v); }
		else if( mCurrentAnimation == 2 ){ alphaPlusTransTest(v); }
		else if( mCurrentAnimation == 3 ){ timeLagAnimationTest(v); }
		else if( mCurrentAnimation == 4 ){ resourceAnimationTest(
				TweenAnimationTestActivity.this, v); }
	}
	
	
	// ߃Aj[V̗
	void alphaAnimationTest( View v ){
		AlphaAnimation alpha = new AlphaAnimation(
				0.0f,  // Jn̓xiO͊Sɓ߁j
				1.0f); // I̓xiP͂܂߂Ȃj

		// RbăAj[V
		alpha.setDuration( 3000 );
		
		// Aj[VI̕\Ԃێ
		alpha.setFillEnabled(true);
		alpha.setFillAfter  (true);
		
		// Aj[VJn
		v.startAnimation(alpha);
	}
	
	
	// ړAj[V̗
	void transAnimationTest( View v ){
		TranslateAnimation trans = new TranslateAnimation(
				// ̉2{̈ʒuJn
				Animation.RELATIVE_TO_SELF, 2,
				// ̕5{̈ʒuiẌʒujŏI
				Animation.RELATIVE_TO_SELF, 0,
				// cɂ͈ړȂ
				Animation.RELATIVE_TO_SELF, 0,
				Animation.RELATIVE_TO_SELF, 0);

		// QbăAj[V
		trans.setDuration( 2000 );
		
		// Aj[VI̕\Ԃێ
		trans.setFillEnabled(true);
		trans.setFillAfter  (true);
		
		// Aj[VJn
		v.startAnimation(trans);
	}
	
	
	// ߂ƈړ̃Aj[Vgݍ킹
	void alphaPlusTransTest(View v){
		
		// ߃Aj[ViRbj
		AlphaAnimation alpha = new AlphaAnimation( 0.0f, 1.0f );
		alpha.setDuration( 3000 );
		
		// ړAj[ViQbj
		TranslateAnimation trans = new TranslateAnimation(
				Animation.RELATIVE_TO_SELF, 2,
				Animation.RELATIVE_TO_SELF, 0,
				Animation.RELATIVE_TO_SELF, 0,
				Animation.RELATIVE_TO_SELF, 0);
		trans.setDuration( 2000 );
		
		// Aj[V̑gݍ킹
		AnimationSet set = new AnimationSet( false );
		set.addAnimation( alpha );
		set.addAnimation( trans );
		
		// Aj[VI̕\Ԃێ
		set.setFillEnabled(true);
		set.setFillAfter  (true);
		
		// Aj[VJn
		v.startAnimation( set );
	}

	
	// ߂ƈړ̃Aj[Vgݍ킹
	void timeLagAnimationTest(View v){
		
		// ߃Aj[ViRbj
		AlphaAnimation alpha = new AlphaAnimation( 0.0f, 1.0f );
		alpha.setDuration( 3000 );
		
		// ړAj[ViQbj
		TranslateAnimation trans = new TranslateAnimation(
				Animation.RELATIVE_TO_SELF, 2,
				Animation.RELATIVE_TO_SELF, 0,
				Animation.RELATIVE_TO_SELF, 0,
				Animation.RELATIVE_TO_SELF, 0);
		trans.setDuration( 2000 );
	
		// ]Aj[V
		RotateAnimation rotate = new RotateAnimation(
				// OxVQOx܂ŕωiQ]j
				0, 720f,
				// ]̒SʒúAr[̒
				Animation.RELATIVE_TO_SELF, 0.5f, 
				Animation.RELATIVE_TO_SELF, 0.5f);

		// Aj[VJnRbォAPbăAj[V
		rotate.setStartOffset( 3000 );
		rotate.setDuration( 4000 );

		// kAj[V
		ScaleAnimation scale = new ScaleAnimation(
				// AP{O{܂ŕω
				1f, 0f,
				1f, 0f,

				// gk̒ŚAr[̒
				Animation.RELATIVE_TO_SELF, 0.5f, 
				Animation.RELATIVE_TO_SELF, 0.5f );

		// Aj[VJnRbォAPbăAj[V
		scale.setStartOffset( 3000 );
		scale.setDuration( 4000 );
		
		
		// Aj[V̑gݍ킹
		AnimationSet set = new AnimationSet( false );
		set.addAnimation( alpha );
		set.addAnimation( trans );
		set.addAnimation( rotate );
		set.addAnimation( scale );
		
		// Aj[VI̕\Ԃێ
		set.setFillEnabled(true);
		set.setFillAfter  (true);
		
		// Aj[VJn
		v.startAnimation( set );
	}

	
	// XML \[X̃Aj[Vǂݍ
	void resourceAnimationTest(Context con, View v){
		// \[X̃Aj[Vǂݍ
		Animation anim = AnimationUtils.loadAnimation( con, R.anim.sample_anim );
		
		// Aj[VJn
		v.startAnimation(anim);
	}
	
}